/*
 * Consciousness.java
 *
 * Created on 11  2007 ., 15:36
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package universum.beings.Yeties;

import java.util.List;
import java.util.Random;
import java.util.concurrent.*;
import universum.bi.*;
import universum.util.*;


import java.util.ArrayList;

import java.lang.Math;

import java.util.Arrays;



/**
 *
 * @author kalugin
 */
public class Consciousness {
    
    
    public final int ARROWS = 35; //35
    public final int STEP = 3; //3
    public final int DIMENSION = 3; //3
    public final int MAX_EXPLORERS_GROUP = 0; //3
    
    public final int MAX_DETACHMENTS = 3;

    public final int STAGE_0_MAX_TURN = 50;
    public final int STAGE_1_MAX_TURN = 180; //150
    
    public final int MAX_GOLDEN_GUARD_STAGE_0 = 2;
    public final int MAX_MEDIUM_GUARD_STAGE_0 = 1;
    public final int MAX_SIMPLE_GUARD_STAGE_0 = 0;

    
    public final int MAX_GOLDEN_GUARD_STAGE_1 = 5; //10
    public final int MAX_MEDIUM_GUARD_STAGE_1 = 2;
    public final int MAX_SIMPLE_GUARD_STAGE_1 = 0; 
    
    
    public final int MAX_GOLDEN_GUARD_STAGE_2 = 50;
    public final int MAX_MEDIUM_GUARD_STAGE_2 = 10;
    public final int MAX_SIMPLE_GUARD_STAGE_2 = 2;
    
    public final int ENOUGH_GOLDEN_GUARD_STAGE_2 = 15;
    public final int ENOUGH_MEDIUM_GUARD_STAGE_2 = 5;
    public final int ENOUGH_SIMPLE_GUARD_STAGE_2 = 1;
    
    public final float ENEMY_KILLED_ENERGY_THRESHOLD = 0.35f;

    
    
//    public PointInfo map[][];
    public boolean is_explored[][];
    
    public List<Entity> initial_explorers;
    
    public int total_initial_explorers = 0;
      
    public List<Task> initial_tasks;
    
    public static Field field;
    
    public List<Yeti_2> population;
    
    public List<Operation> operations = null;
    
    
    enum Stage {
        STAGE_0,
        STAGE_1,
        STAGE_2,
        STAGE_3
    };
    
    public Stage stage;
    
    public List<Location> occupied_list;
    
//    public boolean war_state = false;
//    public float my_forces_power = 0;
//    Location assembly_point;
//    Location attack_point;
    public ArrayBlockingQueue<WarriorDetachment> detachments;

    
    
    /** Creates a new instance of Consciousness */
    public Consciousness( BeingInterface bi, Entity me, List<Yeti_2> population_list ) {
//        this.map = new PointInfo[ Constants.getWidth() ][ Constants.getHeight() ];
        this.is_explored = new boolean[ Constants.getWidth() ][ Constants.getHeight() ];
        this.initial_explorers = new ArrayList();
        this.initial_tasks = new ArrayList();
        this.population = population_list;
        
        this.occupied_list = new ArrayList();
//        this.detachments = new ArrayList();
        this.detachments = new ArrayBlockingQueue( 50 );
        
        this.field = new Field( Constants.getWidth(), Constants.getHeight() );
        
        
        for( int i = 0; i < Constants.getWidth( ); i++ ) {
            for( int j = 0; j < Constants.getHeight(); j ++ ) {
                this.is_explored[i][j] = false;
            }
        }

        int x0 = bi.getLocation( me ).getX();
        int y0 = ( Constants.getHeight() + bi.getLocation( me ).getY() - (STEP * 5) ) % Constants.getHeight();
//                int y0 = bi.getLocation( me ).getY();

        
        int total_rounds = Constants.getHeight() / (ARROWS * STEP);
        
        for( int i = 0; i < ARROWS; i++ ) {
            Task task = new Task();
            
            int level = i * STEP;                        
            
            for( int rounds = total_rounds; rounds >= 0; rounds-- ) {
                int t = level + ( STEP * ARROWS * rounds );

                int x ;
                int y ;   
                Location wploc;

                for( int k = 0; k <= 16; k++ ) {
                    x = (int)( Constants.getWidth() * ( 1.0 * (k - 1) /16 ) );
                    y = t;
                    wploc = bi.createLocation( ( 2 * Constants.getWidth() + ( x0 + x ) ) % Constants.getWidth() , 
                                            ( 2 * Constants.getHeight() + ( y0 + y ) ) % Constants.getHeight() );
                    task.pushWP( wploc );
                }
                
                
                                                
            }
            
            
            initial_tasks.add( task );
        }
        
        switchToStage( Stage.STAGE_0 );
    }
    
    private synchronized boolean addNewWarrior( BeingInterface bi, Yeti_2 yeti ) {
//        System.out.println( "Adding new warrior" );
        if( occupied_list.size() == 0 ) {
            return false;
        }
        
        for( WarriorDetachment group : detachments ) {
            if( group.getCurrentStatus() == WarriorDetachment.Status.NEED_MORE_POWER ) {
                group.addNewWarrior( yeti );
                return true;
            }
        }
        
        if( detachments.size() < MAX_DETACHMENTS ) {
            
            List<Location> still_not_attacked = new ArrayList();
            
            still_not_attacked.addAll( occupied_list );
            
            for( WarriorDetachment group: detachments ) {
                still_not_attacked.remove( group.attack_point );
            }
            
            if( still_not_attacked.size() == 0 ) {
                return false;
            }

            
            Location curr_loc = null;
            
            for( Location loc : still_not_attacked ) {
                int most_weak = Integer.MAX_VALUE;
                int power;

                if( field.isGolden( loc ) ) {
                    power = (int)field.getTotalEnemyMass( loc );
                    if( power < most_weak ) {
                        most_weak = power;
                        curr_loc = loc;
                    }                    
                }
            }
            
            if( curr_loc != null ) {
                letsStartAWar( curr_loc, yeti, bi );
                return true;                    
            }
            
            
            for( Location loc : still_not_attacked ) {
                int most_weak = Integer.MAX_VALUE;
                int power;

                if( true ) {
                    power = (int)field.getTotalEnemyMass( loc );
                    if( power < most_weak ) {
                        most_weak = power;
                        curr_loc = loc;
                    }                    
                }
            }
            
            if( curr_loc != null ) {
                letsStartAWar( curr_loc, yeti, bi );
                return true;                    
            }

        }
        
        return false;
    }
    
    public synchronized void letsStartAWar( Location attack_point, Yeti_2 comander, BeingInterface bi ) {
        WarriorDetachment wg = new WarriorDetachment( attack_point, field, bi );
        wg.addNewWarrior( comander );
        detachments.add( wg );
        for( Yeti_2 yeti : population ) {
            if( yeti.being_kind.getCurrent() == BeingKind.CurrentType.EXPLORER ) {
                if( initial_explorers.contains( yeti ) ) {
                    initial_explorers.remove( yeti );
                    total_initial_explorers--;
                }
                wg.addNewWarrior( yeti );
            }
            if( yeti.being_kind.getCurrent() == BeingKind.CurrentType.GUARDIAN ) {
                if( isEnoughGuarded( yeti.being_kind.getGuardObject() ) ) {
                    this.delGuardian( bi, yeti, yeti.being_kind );
                    wg.addNewWarrior( yeti );
                }
            }
        }
        wg.forceAttack( true ); // !!!!!!!!!!!!!
    }
    
    public boolean isEnoughGuarded( Location loc ) {
        if(  field.isGolden( loc ) && ( field.getGuardsNumber( loc ) > ENOUGH_GOLDEN_GUARD_STAGE_2 ) )  {
            return true;
        }
        if(  field.isMedium( loc ) && ( field.getGuardsNumber( loc ) > ENOUGH_MEDIUM_GUARD_STAGE_2 ) )  {
            return true;
        }

        if(  field.isSimple( loc ) && ( field.getGuardsNumber( loc ) > ENOUGH_SIMPLE_GUARD_STAGE_2 ) )  {
            return true;
        }
        return false;
    }
    
    public synchronized void delWarrior( BeingInterface bi, Yeti_2 yeti ) {
        for( WarriorDetachment group : detachments ) {
            if( group.isMyWarrior( yeti ) ) {
                group.deleteWarrior( yeti );
                return;
            }
        }
    }
    
    private synchronized void processWar( BeingInterface bi ) {
//        System.out.println( "detachments = " + detachments.size() );
        List<WarriorDetachment> remove_candidates = new ArrayList();
        for( WarriorDetachment group : detachments ) {
            group.nextTurn( bi );
            if( group.getCurrentStatus() == WarriorDetachment.Status.WIN ) {
                // win!!!!!!!!!!!
                System.out.println( "War finished. We win!!!!!!!!!!!!!!!1" );
                clearOccupied( group.attack_point );
                remove_candidates.add( group );
//                disbandDetachment( bi, group );
                break;
            } else 
            if( group.getCurrentStatus() == WarriorDetachment.Status.LOSE) {
                // loose......................
                System.out.println( "War finished. We loose...................." );
                remove_candidates.add( group );
//                disbandDetachment( bi, group );
                break;
            }
        }
        for( WarriorDetachment group : remove_candidates ) {
            disbandDetachment( bi, group );
        }
    }
    
    private synchronized void disbandDetachment( BeingInterface bi, WarriorDetachment group ) {
        List<Yeti_2> warrior_list = group.getWarriorList();
        detachments.remove( group );
        System.out.println( "removing detachment" );
        for( Yeti_2 yeti : warrior_list ) {
            yeti.being_kind.switchTo( BeingKind.CurrentType.EXPLORER );
//            System.out.println( "produced new " + yeti.being_kind.getCurrent() );
        }
        
        for( Yeti_2 yeti : warrior_list ) {
            yeti.being_kind = chooseNewBornBeingKind( bi, yeti );
            System.out.println( "produced new " + yeti.being_kind.getCurrent() );
        }
    }
    
    public synchronized BeingKind chooseNewBornBeingKind( BeingInterface bi, Yeti_2 me ) {
        BeingKind new_born = new BeingKind();
        
        Location loc;
        
        switch( stage ) {       
            case STAGE_0:
////                System.out.println( "born in stage_0, max_golden = " + String.valueOf( field.MAX_GOLDEN_GUARDS ) );
//                if( field.atGolden( bi, me ) ) {
//                    loc = field.addGoldenGuard( bi, me );
//                    if( loc != null ) {
//                        new_born.switchTo( BeingKind.CurrentType.GUARDIAN );
//                        new_born.setGuardObject( loc );
//                        System.out.println( "born golden in stage_0" );
//                        return new_born;
//                    }
//                }
//
//                if( total_initial_explorers < ( ARROWS * MAX_EXPLORERS_GROUP ) ) {
//                    new_born.switchTo( BeingKind.CurrentType.EXPLORER );
//                    addExplorer( bi, me, new_born );
//                }
//                
//                break;

// !!!!!!!!!
            case STAGE_1:
                
                if( field.atGolden( bi, me ) ) {
                    loc = field.addGoldenGuard( bi, me );
                    if( loc != null ) {
                        new_born.switchTo( BeingKind.CurrentType.GUARDIAN );
                        new_born.setGuardObject( loc );
                        return new_born;
                    }
                }
                
                if( total_initial_explorers < ( ARROWS * MAX_EXPLORERS_GROUP ) ) {
                    new_born.switchTo( BeingKind.CurrentType.EXPLORER );
                    addExplorer( bi, me, new_born );
                }
                
                if( field.atMedium( bi, me ) ) {
                    loc = field.addMediumGuard( bi, me );
                    if( loc != null ) {
                        new_born.switchTo( BeingKind.CurrentType.GUARDIAN );
                        new_born.setGuardObject( loc );
                        return new_born;
                    }                    
                }

                new_born.switchTo( BeingKind.CurrentType.EXPLORER );                
                return new_born;

            case STAGE_2: 
                        {

                            if( field.atMedium( bi, me ) ) {
                                loc = field.addMediumGuard( bi, me );
                                if( loc != null ) {
                                    new_born.switchTo( BeingKind.CurrentType.GUARDIAN );
                                    new_born.setGuardObject( loc );
//                                        System.out.println( "1111" );
                                    return new_born;
                                }                    
                            }
                              
                              
                            loc = field.addGoldenGuard( bi, me );
                            if( loc != null ) {
                                new_born.switchTo( BeingKind.CurrentType.GUARDIAN );
                                new_born.setGuardObject( loc );
                                return new_born;
                            }
                              
                              
                              
                            if( addNewWarrior( bi, me ) ) {
                                return me.being_kind;
                            }
                              
                            loc = field.addMediumGuard( bi, me );
                            if( loc != null ) {
                                new_born.switchTo( BeingKind.CurrentType.GUARDIAN );
                                new_born.setGuardObject( loc );
//                                        System.out.println( "1111" );
                                return new_born;
                            }  
                            

                            loc = field.addSimpleGuard( bi, me );
                            if( loc != null ) {
                                new_born.switchTo( BeingKind.CurrentType.GUARDIAN );
                                new_born.setGuardObject( loc );
                                return new_born;
                            }
                              
                              
                            new_born.switchTo( BeingKind.CurrentType.EXPLORER );                
//                          System.out.println( "5555" );
                            return new_born;
                        }
                        
        }
        
        new_born.switchTo( BeingKind.CurrentType.EXPLORER );
        return new_born;
    }
    
    
    
    public synchronized void analyzePoints( List<PointInfo> list, BeingInterface bi, Yeti_2 me ) {
        field.analyzePoints( list, me );
        
        processWar( bi );
        
        switch( stage ) {
            case STAGE_0:
                if( bi.getTurnsCount() > STAGE_0_MAX_TURN ) {
                    switchToStage( Stage.STAGE_1 );
                }
                break;
            case STAGE_1:
                if( field.enoughGoldFound() || field.enoughExplored() || bi.getTurnsCount() > STAGE_1_MAX_TURN ) {
                    switchToStage( Stage.STAGE_2 );
                }
                break;
            case STAGE_2:
                if( field.enoughExplored() ) {
                    if( me.being_kind.getCurrent() == BeingKind.CurrentType.EXPLORER ) {
                        if( initial_explorers.contains( me ) ) {
                            initial_explorers.remove( me );
                            total_initial_explorers--;
                        }
                        me.being_kind = chooseNewBornBeingKind( bi, me );
                    }
                }
                break;
        }   
        
    }
    
    public void switchToStage( Stage new_stage ) {
        stage = new_stage;
        System.out.println( " Switch to " + new_stage.toString() );
        
        switch( new_stage ) {
            
            case STAGE_0:
                field.setMaxGoldedGuard( MAX_GOLDEN_GUARD_STAGE_0 );
                field.setMaxMediumGuard( MAX_MEDIUM_GUARD_STAGE_0 );
                field.setMaxSimpleGuard( MAX_SIMPLE_GUARD_STAGE_0 );
                break;
            case STAGE_1:
                field.setMaxGoldedGuard( MAX_GOLDEN_GUARD_STAGE_1 );
                field.setMaxMediumGuard( MAX_MEDIUM_GUARD_STAGE_1 );
                field.setMaxSimpleGuard( MAX_SIMPLE_GUARD_STAGE_1 );
                break;
            case STAGE_2:
                field.setMaxGoldedGuard( MAX_GOLDEN_GUARD_STAGE_2 );
                field.setMaxMediumGuard( MAX_MEDIUM_GUARD_STAGE_2 );
                field.setMaxSimpleGuard( MAX_SIMPLE_GUARD_STAGE_2 );
                break;
        }
    }
    
    public synchronized void setEnemyPowerInfo( BeingInterface bi, Yeti_2 me, Location loc, int total_mass, List<Integer> enemy_list ) {
        field.setEnemyPowerInfo( bi, me, loc, total_mass, enemy_list );
    }
    
    public List<Integer> getEnemyIdList( Location loc ) {
        return field.getEnemyIdList( loc );
    }

    public float getEnemyMass( Location loc, Integer enemy_id ) {
        return field.getEnemyMass( loc, enemy_id );
    }

    
    public List<Yeti_2> getGuardiansList( Location loc ) {
        return field.getGuards( loc );
    }
    
    public synchronized void setOccupied( Location loc ) {
        if( (!field.isGolden( loc )) && (!field.isMedium(loc)) ) {
            if( occupied_list.size() != 0 ) {
                return;
            }
        }
        field.setOccupied( loc );
        if( ! occupied_list.contains( loc ) ) {
            occupied_list.add( loc );
        }
    }

    public synchronized void clearOccupied( Location loc ) {
        field.clearOccupied( loc );
        if( occupied_list.contains( loc ) ) {
            occupied_list.remove( loc );
        }
    }

    public synchronized void delGuardian( BeingInterface bi, Being me, BeingKind guardian ) {
        field.delGuard( bi, me, guardian.getGuardObject() );
    }
    
    private void addExplorer( BeingInterface bi, Yeti_2 yeti, BeingKind explorer ) {
        explorer.setTask( initial_tasks.get( total_initial_explorers % ARROWS ) );
        total_initial_explorers++;
        initial_explorers.add( yeti );
    }
    
    public void delExplorer( BeingInterface bi, Yeti_2 killed ) {
        if( initial_explorers.contains( killed ) ) {
            total_initial_explorers--;    
            
            Yeti_2 last_explorer = (Yeti_2)initial_explorers.get( initial_explorers.size() - 1 );
            last_explorer.setTask( killed.getTask() );
            
            initial_explorers.remove( killed );
        }
    }


    
    
    public void setInfo( List<PointInfo> list ) {
        for( PointInfo info : list ) {
//            if( ! is_explored[ info.getLocation().getX() ][ info.getLocation().getY() ] ) {
//                map[ info.getLocation().getX() ][ info.getLocation().getY() ] = info;
                is_explored[ info.getLocation().getX() ][ info.getLocation().getY() ] = true;
//            }
        }
    }
    
    
    public synchronized void initializeNextTurn( BeingInterface bi ) {
        int guards_count[][]= new int[ Constants.getWidth() ][ Constants.getHeight() ];
        List<Yeti_2> guards[][] = new ArrayList[ Constants.getWidth() ][ Constants.getHeight() ];
        
        List<Yeti_2> remove_candidates = new ArrayList();
        
        operations = new ArrayList();
        
        
        for( int i = 0; i < Constants.getWidth(); i++ ) {
            for( int j = 0; j < Constants.getHeight(); j++ ) {
                guards_count[i][j] = 0;
                guards[i][j] = null;
            }
        }
        
        
        for( Yeti_2 yeti : population ) {
            
            if( yeti.getBeingKind().getCurrent() == BeingKind.CurrentType.GUARDIAN ) {
                int x,y;
                
                x = yeti.getBeingKind().getGuardObject().getX();
                y = yeti.getBeingKind().getGuardObject().getY();
                
                guards_count[x][y]++;
                
                if( guards[x][y] == null ) {
                    guards[x][y] = new ArrayList();
                }
                
                guards[x][y].add( yeti );            
            }
            try {
                yeti.analyzeEnemyPower( bi );
            }
            catch ( NullPointerException e ) {
//                population.remove( yeti );
                remove_candidates.add( yeti );
                System.out.println( "exception happened " + yeti.id );
            }
                
        }
        
        for( Yeti_2 yeti : remove_candidates ) {
            population.remove( yeti );
        }
        
        
        field.setGuardsCountList( guards_count );
        field.setGuardsList( guards );
    }
    
    public synchronized boolean commitAttackOpearation( BeingInterface bi, Integer vicimID, Location where, Yeti_2 me, float damage ) {
        float current_damage = 0;
        
        for( Operation op : operations ) {
            if( ( op.getOperationKind() == Operation.OperationKind.ATTACK ) &&
                 ( op.getAnimal().intValue() == vicimID.intValue() ) ) {                
                current_damage += op.getValue();
//                System.out.println( vicimID.toString() + " is alredy damaged, its damage=" + current_damage + " its mass=" + getEnemyMass( where, vicimID ) );
            }
        }
        
        if( current_damage > ENEMY_KILLED_ENERGY_THRESHOLD * getEnemyMass( where, vicimID ) ) {
//            System.out.println( vicimID.toString() + " is alredy killed, its damage=" + current_damage + " its mass=" + getEnemyMass( where, vicimID ) );
            return false;
        }
        
        Operation new_operation = new Operation( Operation.OperationKind.ATTACK );
        
        new_operation.attackOperation( vicimID, damage );
        
        operations.add( new_operation );
        
        return true;
    }
    
    
    public void achtung( BeingInterface bi, Yeti_2 me ) {
        Location achtung_loc = bi.getLocation( me );
        
        if( field.isGolden( achtung_loc )  && ( ( stage == Stage.STAGE_0 ) || ( stage == Stage.STAGE_1 ) ) ) {
            me.analyzeEnemyPower( bi );
            WarriorDetachment wg = new WarriorDetachment( achtung_loc, field, bi );
            for( Yeti_2 yeti : population ) {
                if( ( yeti.being_kind.getCurrent() == BeingKind.CurrentType.EXPLORER )
                     && ( bi.distance( achtung_loc, bi.getLocation( yeti ) ) < 30 ) ) {
                    if( initial_explorers.contains( yeti ) ) {
                        initial_explorers.remove( yeti );
                        total_initial_explorers--;
                    }                    
                    wg.addNewWarrior( yeti );
                }
            }
            if( wg.getWarriorList().size() > 0 ) {
                detachments.add( wg );
                wg.forceAttack( true );
            }
            
        }
    }    
    
    public Location moveTo( BeingInterface bi, Yeti_2 yeti, Location loc ) {

        List<Location> all_loc = bi.getReachableLocations( yeti );
        
        int len = all_loc.size();
        
//        bi.log( (Being)yeti , "!!!! " + all_loc.toString() );
        
        
        Location sorted_loc[] = all_loc.toArray( new Location[ len ] );
        
        LocationComparator  comparator = new LocationComparator( bi, loc );
        
        Arrays.sort( sorted_loc, comparator );
        
        // need to improve !!!!!!!!!!!!!!!!1
        
//        bi.log( (Being)yeti , "x=" + String.valueOf( bi.getLocation( yeti ).getX() ) + 
//                                " y=" + String.valueOf( bi.getLocation( yeti ).getY() +
//                                " x_1=" + String.valueOf( sorted_loc[0].getX() ) ) + 
//                                " y_1=" + String.valueOf( sorted_loc[0].getY() ) );

        List<Location> candidate_list = new ArrayList();
        candidate_list.add( sorted_loc[0] );
        
        for( int i = 1; i < len; i++ ) {
            if( bi.distance( sorted_loc[i - 1], loc ) == bi.distance( sorted_loc[i], loc ) ) {
                candidate_list.add( sorted_loc[i] );
            } else {
                break;
            }
        }
        
        int candate_len = candidate_list.size();
        
        double decar_len = 900000000.0;
        
        Location candidate = sorted_loc[0];
        
        for( int i = 0; i < candate_len; i++ ) {
            Location cand = candidate_list.get(i);
//            bi.log( (Being)yeti , " cand_x=" + String.valueOf( cand.getX() ) + 
//                                  " cand_y=" + String.valueOf( cand.getY() ) );
            double decar_len2 = ( cand.getX() - loc.getX() ) * ( cand.getX() - loc.getX() ) 
                              + ( cand.getY() - loc.getY() ) * ( cand.getY() - loc.getY() );

            if( decar_len2 < decar_len ) {
                decar_len = decar_len2;
                candidate = cand;
            }
        }

//       bi.log( (Being)yeti , " move_x=" + String.valueOf( candidate.getX() ) + 
//                             " move_y=" + String.valueOf( candidate.getY() ) );

        
        return candidate;
        
    }
    
    private Location followTask( BeingInterface bi, Yeti_2 yeti ) {
        
        if( ! yeti.getTask().tasksLeft() ) {
            initial_explorers.remove( yeti );
            return null;  
        }
        
        if( yeti.getTask().peekWP() == bi.getLocation( yeti ) ) {
            yeti.getTask().popWP();
        }

        if( ! yeti.getTask().tasksLeft() ) {
            initial_explorers.remove( yeti );
            return null;  
        }

//        bi.log( (Being)yeti , "x=" + String.valueOf( bi.getLocation( yeti ).getX() ) + 
//                                " y=" + String.valueOf( bi.getLocation( yeti ).getY() ) );
//
//        
//        bi.log( (Being)yeti , "wp_x=" + String.valueOf( yeti.getTask().peekWP().getX() ) + 
//                                " wp_y=" + String.valueOf( yeti.getTask().peekWP().getY() ) );
            
        return moveTo( bi, yeti, yeti.getTask().peekWP() );
    }
  
    public Location whereToGo( BeingInterface bi, Yeti_2 yeti ) {
        
        Location res;
        
        if( initial_explorers.contains( yeti ) ) {
//            bi.log( yeti, "following the task" );
            // TODO: move according to task
            res = followTask( bi, yeti );
            if( res != null ) {
                return res;
            }
        }
                
        // move to best reachable non-explored
        
        res = field.getReachableNonExplored( bi.getLocation( yeti ), bi, yeti );
        
        if( res != null ) {
//            bi.log( yeti, "moving to reachable non-explored" );
            return res;
        }

        
        // move to nearest non-explored
        
        res = field.getNearestNoneExplored( bi.getLocation( yeti ), bi, yeti );
        
        if( res != null ) {
//            bi.log( yeti, "moving to nearest non-explored" );
            return moveTo( bi, yeti, res );
        }
        
        // need to be modified
        
        return null;
        
//        List<Location> all_loc = bi.getReachableLocations( yeti );
////        bi.log( yeti, "moving to random place" );
//        // nothing good around, go to random place
//        int idx = Util.rnd(all_loc.size());
//        return all_loc.get(idx);
    }
    
}
