/*
 * Field.java
 *
 * Created on 16  2007 ., 9:33
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package universum.beings.Yeties;


import universum.bi.*;
import universum.util.*;
import java.util.List;
import java.util.ArrayList;

import universum.beings.Yeties.*;


/**
 *
 * @author kalugin
 */
public class Field {
    
    public boolean is_explored[][];
    
    public boolean is_source[][];
    
    public boolean is_golden[][];
    
    public boolean is_medium[][];
    
    public boolean is_simple[][];
    
    public int guards_count[][];
    
    private List<Yeti_2> guards[][];
    
    public float energy[][];
    
    private boolean occupied[][];
    MyPointInfo enemies[][];
    
    public int MAX_GOLDEN_GUARDS;
    public int MAX_MEDIUM_GUARDS;
    public int MAX_SIMPLE_GUARDS;
    
    private List<Location> golden;
    
    private List<Location> medium;
    
    private List<Location> simple_source;
    
//    private List<Location> totaly_guarded;
    
    private int max_x,max_y;
    
    private static boolean all_explored = false;
    private static int fields_explored = 0;
    
    
    /** Creates a new instance of Field */
    public Field( int x, int y ) {
        this.max_x = x;
        this.max_y = y;
        
        is_explored = new boolean[x][y];
        is_source = new boolean[x][y];
        is_golden = new boolean[x][y];
        is_medium = new boolean[x][y];
        is_simple = new boolean[x][y];
        energy = new float[x][y];
        
        occupied = new boolean[x][y];
        
        enemies = new MyPointInfo[x][y];
                
        guards_count = new int[x][y];
        guards = new ArrayList[x][y];
        
        golden = new ArrayList();
        medium = new ArrayList();
        simple_source = new ArrayList();
  //      totaly_guarded = new ArrayList();
        
        for( int i = 0; i < x; i++ ) {
            for( int j = 0; j < y; j++ ) {
                is_explored[i][j] = false;
                is_source[i][j] = false;
                is_golden[i][j] = false;
                is_medium[i][j] = false;
                is_simple[i][j] = false;
                energy[i][j] = 0;
                guards_count[i][j] = 0;
                occupied[i][j] = false;
                guards[i][j] = null;
                enemies[i][j] = null;
            }
        }        
    }
    
    public synchronized void setOccupied( Location loc ) {
        occupied[ loc.getX() ][ loc.getY() ] = true;
    }

    public synchronized void clearOccupied( Location loc ) {
        occupied[ loc.getX() ][ loc.getY() ] = false;
        
//        System.out.println( "field : removing occupied flag from" + loc.toString() );
    }
    
    public synchronized void setMaxGoldedGuard( int gg ) {
        MAX_GOLDEN_GUARDS = gg;
    }
    
    public synchronized void setMaxMediumGuard( int mg ) {
        MAX_MEDIUM_GUARDS = mg;
    }

    
    public synchronized void setMaxSimpleGuard( int sg ) {
        MAX_SIMPLE_GUARDS = sg;
    }

    
//    public Location addGuard( BeingInterface bi, Being me ) {
//        Location loc = null;
//
//        loc = getNearestGolden( bi, me );
//        
//        while ( loc != null ) {
//            List<Location> excluding = new ArrayList();
//            if( guards[ loc.getX() ][ loc.getY() ] < MAX_GOLDEN_GUARDS ) {
//                guards[ loc.getX() ][ loc.getY() ]++;
//                return loc;
//            }
//            excluding.add( loc );
//            loc = getNearestGolden( bi, me, excluding );
//        } 
//        
//        loc = getNearestSource( bi, me );
//        while ( loc != null ) {
//            List<Location> excluding = new ArrayList();
//            if( guards[ loc.getX() ][ loc.getY() ] < MAX_SIMPLE_GUARDS ) {
//                guards[ loc.getX() ][ loc.getY() ]++;
//                return loc;
//            }
//            excluding.add( loc );
//            loc = getNearestSource( bi, me, excluding );
//        }
//        
//        return null;
//    }
    
    public Boolean isGolden( Location loc ) {
        return is_golden[ loc.getX() ][ loc.getY() ];
    }
    public Boolean isMedium( Location loc ) {
        return is_medium[ loc.getX() ][ loc.getY() ];
    }

    public Boolean isSimple( Location loc ) {
        return is_simple[ loc.getX() ][ loc.getY() ];
    }
    
    public Location selectAssemblyPoint( Location loc, BeingInterface bi ) {
        int rad = 2;
        int x0 = loc.getX();
        int y0 = loc.getY();
        int x,y;
        
        List <Location> list = new ArrayList();
        
        for( int i = -rad; i <=rad; i++ ) {
            for( int j = -rad; j <=rad; j++ ) {
                x = ( max_x + x0 + i ) % max_x;
                y = ( max_y + y0 + j ) % max_y;
                
                if( ( ! occupied[x][y] ) && ( ! is_source[x][y] ) && ( bi.distance( loc, bi.createLocation( x, y ) ) == rad ) ) {
                    list.add( bi.createLocation( x, y ) );
                }
            }
        }
        
        if( list.size() > 0 ) {
            int idx = Util.rnd( list.size() );
            return list.get( idx );
        }
        
        for( int i = -rad; i <=rad; i++ ) {
            for( int j = -rad; j <=rad; j++ ) {
                x = ( max_x + x0 + i ) % max_x;
                y = ( max_y + y0 + j ) % max_y;
                
                if( ( ! occupied[x][y] ) ) {
                    return bi.createLocation( x, y );
                }
            }
        }
        
        return null;
        
    }

    
    public synchronized Location addGoldenGuard( BeingInterface bi, Being me ) {
        return addGuard( bi, me, this.golden, MAX_GOLDEN_GUARDS );
    }

    public synchronized Location addMediumGuard( BeingInterface bi, Being me ) {
        return addGuard( bi, me, this.medium, MAX_MEDIUM_GUARDS );
    }
    
    public synchronized Location addSimpleGuard( BeingInterface bi, Being me ) {
        return addGuard( bi, me, this.simple_source, MAX_SIMPLE_GUARDS );
    }


    
    public synchronized Location addGuard( BeingInterface bi, Being me, List<Location> where, int max ) {
        List <Location> except = new ArrayList();
        Location my_loc = bi.getLocation( me );
        for( Location l : where ) {
            if( ( guards_count[ l.getX() ][ l.getY() ] >= max ) ||
                ( occupied[ l.getX() ][ l.getY() ] ) ) {
                except.add( l );
            }
        }
        
        Location loc = getNearest( my_loc, where, except, bi );
        
        if( loc != null ) {
            guards_count[ loc.getX() ][ loc.getY() ]++;
            return loc;
        }
        
        return null;
        
                        
//        Location loc = null;
//        loc = getNearest( bi.getLocation( me ), where, totaly_guarded, bi );
//        
//        while ( loc != null ) {            
//
//            if( ( guards[ loc.getX() ][ loc.getY() ] < max ) && 
//                ( !occupied[ loc.getX() ][ loc.getY() ] ) ) {
//                guards[ loc.getX() ][ loc.getY() ]++;
////                System.out.println( "adding guard to " + loc.toString() );
////                System.out.println( "   addGuard " + loc.toString()  + " curr=" + String.valueOf( guards[ loc.getX() ][ loc.getY() ] ) );
//                return loc;
//            } else {
//                  
////                System.out.println( "lazha wyshla" + loc.toString() + " occ=" + String.valueOf( occupied[ loc.getX() ][ loc.getY() ] ) + " gurargs=" + String.valueOf( guards[ loc.getX() ][ loc.getY() ] ) );
//            }
//            totaly_guarded.add( loc );
//            loc = getNearest( bi.getLocation( me ), where, totaly_guarded, bi );            
//        } 
//    
//        return null;
    }
    
    public boolean enoughGoldFound() {
        int count = 0;
        for( Location loc : golden ) {
            if( ! occupied[ loc.getX() ][ loc.getY() ] ) {
                count++;
            }
        }
        return ( count >= 3 );
    }
    
    public boolean enoughExplored() {
        return ( (fields_explored / ( max_x * max_y )) > 0.95 );
    }
    
    public synchronized void setEnemyPowerInfo( BeingInterface bi, Yeti_2 me, Location loc, int total_mass, List<Integer> enemy_list ) {
        int x = loc.getX();
        int y = loc.getY();
        
        enemies[x][y] = new MyPointInfo();
        for( Integer enemy : enemy_list ) {
            enemies[x][y].add( enemy, bi.getMass( me, enemy ) );
        }
//        enemies[ loc.getX() ][ loc.getY() ] = enemy_list;
    }
    
    public float getTotalEnemyMass( Location loc ) {
        return enemies[ loc.getX() ][ loc.getY() ].getEnemyTotalMass();
    }
    
    public List<Integer> getEnemyIdList( Location loc ) {
        return enemies[ loc.getX() ][ loc.getY() ].getEnemyList();
    }
    
    public float getEnemyMass( Location loc, Integer enemy_id ) {
        return enemies[ loc.getX() ][ loc.getY() ].getEnemyMass( enemy_id );
    }

    
    public synchronized void delGuard( BeingInterface bi, Being me, Location guarded ) {
        guards_count[ guarded.getX() ][ guarded.getY() ]--;
        
//        System.out.println( "delGuard " + guarded.toString() + " curr=" + String.valueOf( guards[ guarded.getX() ][ guarded.getY() ] ) );
    }

    public synchronized int getGuardsNumber( Location guarded ) {
        return guards_count[ guarded.getX() ][ guarded.getY() ];
    }
    
    public boolean atGolden( BeingInterface bi, Entity me ) {
        Location loc = bi.getLocation( me );
        return golden.contains( loc );
//        return is_golden[ loc.getX() ][ loc.getY() ];
    }

    public boolean atMedium( BeingInterface bi, Entity me ) {
        Location loc = bi.getLocation( me );
        return medium.contains( loc );
//        return is_medium[ loc.getX() ][ loc.getY() ];
    }
    
    
    public List<Location> getGolden() {
        return golden;
    }
    
    public List<Location> getSimpleSource() {
        return simple_source;
    }
    
    public void setGuardsCountList( int new_guards[][] ) {
        this.guards_count = new_guards;
    }
    
    public void setGuardsList( List<Yeti_2> list[][] ) {
        guards = list;
    }
    
    public List<Yeti_2> getGuards( Location loc ) {
        return guards[ loc.getX() ][ loc.getY() ];
    }


    
    public synchronized void analyzePoints( List<PointInfo> list, Being me ) {
        for( PointInfo pi : list ) {
            Location loc = pi.getLocation();
            int x = loc.getX();
            int y = loc.getY();
            energy[x][y] = pi.getCount( me );
            
            if( energy[x][y] >= 1.0 ) {
                energy[x][y] -= 1;
            }
            
            if( is_explored[x][y] ) {
                continue;
            }
            
//            System.out.println( loc.toString() + " explored, total=" + String.valueOf( fields_explored ) );
            
            is_explored[x][y] = true;
            fields_explored++;
            
            if( fields_explored == max_x * max_y ) {
                all_explored = true;
            }
                
            float growth_rate = pi.getGrowthRate( me );
            float max_energy = pi.getMaxCount( me );

            if( growth_rate > 0 ) {
                is_source[x][y] = true;
                if( growth_rate >= ( Constants.BORN_BONUS_GROWTH * 0.8 ) ) {
                    is_golden[x][y] = true;
                    golden.add( pi.getLocation() );
                    System.out.println( "golden found!" + "x =" +
                            String.valueOf( x ) + " y=" + String.valueOf( y ) + 
                            " now golden = " + String.valueOf( this.golden.size() + 
                            " growth_rate=" + String.valueOf( growth_rate )) );
                } else if( growth_rate >= ( Constants.GROW_REGULAR * 2 ) ) {
                    is_medium[x][y] = true;
                    medium.add( pi.getLocation() );
                    System.out.println( "medium found!" + "x =" +
                            String.valueOf( x ) + " y=" + String.valueOf( y ) + 
                            " now medium = " + String.valueOf( this.medium.size() + 
                            " growth_rate=" + String.valueOf( growth_rate )) );
                } else {
                    is_simple[x][y] = true;
                    simple_source.add( pi.getLocation() );
                }
            }

        }
    }
    
    private synchronized int howManyNonExploredNear( int x0, int y0 ) {
        int len = 1;
        int x, y;
        int res = 0;
        for( int i = -len; i <= len; i++  ) {
            for( int j = -len; j <= len; j++ ) {
                x = ( max_x + x0 + i ) % max_x;
                y = ( max_y + y0 + j ) % max_y;
                if( ! is_explored[x][y] ) {
                    res++;
                }
            }
        }
        return res;
    }
    
    public synchronized Location getReachableNonExplored( Location loc, BeingInterface bi, Yeti_2 yeti ) {
        List <Location> all[] = new ArrayList[10];
        int len0 = ( int )( yeti.S );
        
        for( int i = 0; i < 10; i++ ) {
            all[i] = new ArrayList();
        }
                
        if( all_explored ) {
            return null;
        }
        
        int x0 = loc.getX();
        int y0 = loc.getY();
        
        for( int len = len0; len > 0; len-- ) {
            for( int j = -len; j <= len; j++ ) {
                for( int i = -len; i <=len; i++ ) {
                    int x = ( max_x + x0 + i ) % max_x;
                    int y = ( max_y + y0 + j ) % max_y;      
//                    System.out.println( "non_explored = " +  howManyNonExploredNear( x, y ) );
                    all[ howManyNonExploredNear( x, y ) ].add( bi.createLocation( x, y ) );
                }
            }
        }
        
        for( int i = 9; i > 0; i-- ) {
            if( all[i].size() > 0 ) {
                int idx = Util.rnd( all[i].size() );
                return all[i].get( idx );
            }
        }
        
        return null;
    }
    
    public synchronized Location getNearestNoneExplored( Location loc, BeingInterface bi, Yeti_2 yeti ) {
        
        List <Location> all[] = new ArrayList[9];
        int len0 = ( int )( yeti.S );
                
        if( all_explored ) {
            return null;
        }
        
        int x0 = loc.getX();
        int y0 = loc.getY();
        
        for( int len = len0 + 1; len <= ( max_x / 2) + 1; len++ ) {
            for( int j = -len; j <= len; j++ ) {

                int x = ( max_x + x0 + len ) % max_x;
                int y = ( max_y + y0 + j ) % max_y;

                if( ! is_explored[ x ][ y ] ) 
                    return bi.createLocation( x, y );

                x = ( max_x + x0 - len ) % max_x;
                y = ( max_y + y0 + j ) % max_y;
                if( ! is_explored[ x ][ y ] ) 
                    return bi.createLocation( x, y );

                x = ( max_x + x0 + j ) % max_x;
                y = ( max_y + y0 + len ) % max_y;
                if( ! is_explored[ x ][ y ] ) 
                    return bi.createLocation( x, y );

                x = ( max_x + x0 + j ) % max_x;
                y = ( max_y + y0 - len ) % max_y;
                if( ! is_explored[ x ][ y ] ) 
                    return bi.createLocation( x, y );

            }
        }
        
        all_explored = true;
        
        return null;
    }
    
    
    public Location getNearestSimpleSource( BeingInterface bi, Entity me ) {
        return getNearest( bi.getLocation( me ), simple_source, null, bi );
    }

    public Location getNearestSimpleSource( BeingInterface bi, Entity me, List<Location> excluding ) {

        return getNearest( bi.getLocation( me ), simple_source, excluding, bi );
    }

    public Location getNearestGolden( BeingInterface bi, Entity me ) {
        return getNearest( bi.getLocation( me ), golden, null, bi );
    }

    public Location getNearestGolden( BeingInterface bi, Entity me, List<Location> excluding ) {
        return getNearest( bi.getLocation( me ), golden, excluding, bi );
    }

    public Location getNearestMedium( BeingInterface bi, Entity me ) {
        return getNearest( bi.getLocation( me ), medium, null, bi );
    }

    public Location getNearestMedium( BeingInterface bi, Entity me, List<Location> excluding ) {
        return getNearest( bi.getLocation( me ), medium, excluding, bi );
    }
    
    
    
    public synchronized Location getNearest( Location my_loc, List<Location> from, List<Location> excluding, BeingInterface bi ) {
        List<Location> list = new ArrayList();
        
        for( Location elem : from ) {
            list.add( elem );
        }
        
        if( excluding != null ) {
            list.removeAll( excluding );
        }
        Location curr_loc = null;
        float curr_distance = 10000;
        
        for( Location loc: list ) {
            float distance = curr_distance;

            if( my_loc != null ) {
                distance = bi.distance( my_loc, loc );
            }
            
            
            if( distance < curr_distance ) {
                curr_distance = distance;
                curr_loc = loc;
            }
        }
        return curr_loc;
    }
    
}
