/*
 * Yeti_1.java
 *
 * Created on 10  2007 ., 12:27
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package universum.beings.Yeties;

import universum.bi.*;
import universum.util.*;

/**
 *
 * @author kalugin
 */

// when developing - write descriptor based on template.properties 
// do java -jar universum.jar -makebeing my.properties 
// add line like
//  universum.beings.BeingTemplate=my.properties:My Name 
// into beings.properties and make clean

public class Yeti_1 implements Being {
 
    // initial parameters
    // mass
    static final float M0 = 10f;
    // and speed
    static final float S0 = 1f;


    
    enum BeingKind {
        BEING_KIND_INITIAL,
        BEING_QUEEN,
        BEING_SCOUT,
        BEING_WARRIOR
    };
    
    
    enum BeingState {
        BEING_STATE_INITIAL,
        QUEEN_EAT,
        QUEEN_MULTIPLY
    };
    
    public BeingKind being_kind = BeingKind.BEING_KIND_INITIAL;
    public BeingState being_state = BeingState.BEING_STATE_INITIAL;
    
    public Event action;
    
    public float M;
    public float S;
    
    /** Creates a new instance of Yeti_1 */
    // usually must be empty    
    public Yeti_1() {
    }
    
    // main entry point of the creature - its actions in the world
    public synchronized Event makeTurn(BeingInterface bi) {
        

        
        while( true ) {
            switch( this.being_kind ) {
                case BEING_KIND_INITIAL:
                    this.being_kind = BeingKind.BEING_QUEEN;
                    this.being_state = BeingState.QUEEN_EAT;
                    continue;                    
                case BEING_QUEEN:
                    this.being_kind = this.queenStateMachine( bi );
                    break;
            }
            
            break;
        }
        
        bi.log(this, "being_kind = " + String.valueOf( this.being_kind ) + 
                     "  being_state = " + String.valueOf( this.being_state )/* + 
                     "  action = " + ( this.action ).toString()*/ );

        return this.action;
    }
    
    // notification on external events
    public synchronized void processEvent(BeingInterface bi, Event e) {        
    }
    
    public BeingKind queenStateMachine( BeingInterface bi ) {
        
        // how much energy do we have now
        float e = bi.getEnergy(this);

        while( true ) {
            switch( this.being_state ) {
                case QUEEN_EAT:

                    if( e >= Constants.K_toborn ) {
                        this.being_state = BeingState.QUEEN_MULTIPLY;
                        continue;
                    }
                    this.eatFood();
                    break;
                case QUEEN_MULTIPLY:
                    this.multiply();
                    this.being_state = BeingState.QUEEN_EAT;
                    break;
            }
            break;
        }
        
        return BeingKind.BEING_QUEEN;
    }
    
    public void eatFood() {
        this.action = new Event( EventKind.ACTION_EAT, M );
    }
    
    public void multiply() {
        this.action =  new Event( EventKind.ACTION_BORN, getParams() );
    }
    
    // name of this creature
    public String getName() {
        return "Yeti 1";
    }
    
    
    
    // your name, as shown in winners table
    public String getOwnerName() {
        return "your name";
    }
    
    // this method is invoked once per game, to make sure all static 
    // are properly inited
    public void reinit(UserGameInfo info) {
    }
    
    // return our parameters
    public BeingParams getParams() {
        BeingParams bp = new BeingParams(M0, S0);
        return bp;
    }

    
    private void init(BeingInterface bi, Integer id, BeingParams bp) {
         this.M  = bp.M;
         this.S  = bp.S;
    }

}


