/*
 * Yeti_2.java
 *
 * Created on 13  2007 ., 18:54
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package universum.beings.Yeties;


import universum.bi.*;
import universum.util.*;
import java.util.List;
import java.util.ArrayList;
import java.util.Arrays;

import universum.beings.Yeties.*;

/**
 *
 * @author kalugin
 */
public class Yeti_2 implements Being  {
    
    static Object bossHandle = null;
    
    static List<Yeti_2> population;
    
    static Consciousness razum;
    
    public boolean log_on = false;
    

    // initial parameters
    // mass 
    public float M0 = 10f;
    // and speed
    public float S0 = 3f;
    // when energy level here is less than this - should start looking for better place 
    static final float E_min = 0.5f;
    // which energy level is acceptable to select this point as new location
    static final float E_min2 = 0.1f;
    // minimum of energy one should have before bearing baby
    static final float E_born = 0.8f;
    
    // only if our total mass multiplicated on this coef is bigger than 
    // enemy total mass, we will try to attack
    
    static final float E_attack_coef = 1.25f;
    
    static final float GUARDIAN_ENERGY_GIVE_THRESHOLD = 0.2f;
       
    // local copy of params
    public float M;
    public float S;
    
    public final float E_guard_attck_coef = 0.51f;
    
    // threshold to eat
    private float E_eat;
    
    // array to store info about other beings
    Integer[] others;
    // our own id
    Integer id;
    
    public Event take_action = null;
    
    // population control
    static int maxCount = 200;
    static int currentCount = 0;
    
    public static int current_turn = -1;
        
    
    
    enum States {
        y0_INITIAL,
        y1_EXPLORER_BORN,
        y2_EXPLORER_SEARCH_FOOD,
        y3_EXPLORER_EAT,
        y4_EXPLORER_ATTACK,
        
        
        y1_GUARDIAN_BORN,
        y2_GUARDIAN_MOVE_TO_SOURCE,
        y3_GUARDIAN_GUARD_SOURCE,
        y4_GUARDIAN_FIGHT,
        y5_GUARDIAN_EAT,
        y6_GUARDIAN_MOVE_AND_ATTACK,
        y7_GUARDIAN_TRY_TO_GRANT,
                
        y1_WARRIOR_MOVE_TO_ASSEMBLY,
        y2_WARRIOR_READY_TO_ATTACK,
        y3_WARRIOR_ATTACK,
        y4_WARRIOR_SWITCH_TO_GUARDIAN
    };
    
    
    public BeingKind being_kind;
    
    public States being_state  = States.y0_INITIAL;

    
    /** Creates a new instance of Yeti_2 */
    public Yeti_2() {
    }
    
    public void setTask( Task task ) {
        being_kind.setTask( task );
    }
    
    public Task getTask() {
        return being_kind.getTask();
    }

    public void log( BeingKind.CurrentType type, BeingInterface bi, String message ) {
       bi.log( this, type.toString() + bi.getLocation( this ) + ": " + message );
    }
    
    // this one is the essence of your being - it's invoked once a turn
    // and lets your being do something
    public synchronized Event makeTurn(BeingInterface bi) {
        // information about point we're in
        PointInfo pi = bi.getPointInfo(this);
        // how much energy do we have now
        float e = bi.getEnergy(this);
        // how much energy available at cour current location
        float avail = pi.getCount(this) - 1;
        
        
        if( bi.getTurnsCount() > current_turn ) {
            current_turn = bi.getTurnsCount();
            razum.initializeNextTurn( bi );
        }
        
        
        List<PointInfo> all_points = new ArrayList();
        all_points.addAll( bi.getNeighbourInfo( this ) );        
        all_points.add( pi );
        
        razum.analyzePoints( all_points, bi, this );
        
        
        take_action = null;
        
        // select action
        switch( being_kind.getCurrent() ) {
            case EXPLORER:
                a1_explorer( bi );
                break;
            case GUARDIAN:
                a2_guardian( bi );
                break;
            case WARRIOR:
                a3_warrior( bi );
                break;
        }
        
        return take_action;
    }
    
    
    private void a1_explorer( BeingInterface bi ) {
        // information about point we're in
        PointInfo pi = bi.getPointInfo(this);
        // how much energy do we have now
        float e = bi.getEnergy(this);
        // how much energy available at cour current location
        float avail = pi.getCount(this) - 1;

        // array of all entities here        
        Integer[] ids = pi.getEntities( this, null );        
         // index of potential victum
        Integer victum = 0;

        
        boolean e0_FOOD_AVAILABLE = false;
        boolean e1_ENOUGH_ENERGY_TO_BORN = false;
        boolean e2_VICTUM_AVAILABLE = false;
        
        
        if( avail > ( M * E_min ) && ( avail > pi.getGrowthRate( this ) ) ) {
//            bi.log( this, bi.getLocation( this ) + " food available " + String.valueOf( avail ) + " g.r. = " + 
//                    String.valueOf( pi.getGrowthRate( this ) ) );
            e0_FOOD_AVAILABLE = true;
        } else {
//            bi.log( this, bi.getLocation( this ) + " food NOT available " + String.valueOf( avail ) + " g.r. = " + 
//                String.valueOf( pi.getGrowthRate( this ) ) );

        }
        
        if( e >= ( M * E_born ) ) {
            e1_ENOUGH_ENERGY_TO_BORN = true;
        }

                
        if( ids.length > 1 ) {
            List<Integer> enemy = new ArrayList();
            List<Integer> friend = new ArrayList();
            for( int i = 0; i < ids.length; i++ ) {
                if( bossHandle != bi.getOwner(this, ids[i]) ) {
                    enemy.add( ids[i] );
                } else {
                    friend.add( ids[i] );
                }
            }
            
            if( enemy.size() != 0 ) {

                int enemy_mass = 0;
                int friend_mass = 0;

                float curr_enemy_mass;
                float min_enemy_mass = 10000f;

                for( int i = 0; i < enemy.size(); i++ ) {
                    curr_enemy_mass = bi.getMass( this, enemy.get( i ).intValue() );
                    enemy_mass += curr_enemy_mass;
                    if( curr_enemy_mass < min_enemy_mass ) {
                        min_enemy_mass = curr_enemy_mass;
                        victum = enemy.get( i );
                    }
                }

                for( int i = 0; i < friend.size(); i++ ) {
                    friend_mass += bi.getMass( this, friend.get( i ).intValue() );
                }

                if( friend_mass * E_attack_coef > enemy_mass/* && 
                  ( ( e / M - Constants.K_fightcost - Constants.K_emin ) * M  > 
                        min_enemy_mass * Constants.K_retaliate )*/ ) {
                    e2_VICTUM_AVAILABLE = true;
                }
            
            }
        }
        
        // Finite-State Machine
        
        while( true ) {
            switch( being_state ) {
                default:
                    being_state = States.y1_EXPLORER_BORN;
                    log( BeingKind.CurrentType.EXPLORER, bi, "     " );
                    continue;
                case y3_EXPLORER_EAT:
                    log( BeingKind.CurrentType.EXPLORER, bi, "     " );
                    z3_explorer_eat( bi );
                    log( BeingKind.CurrentType.EXPLORER, bi, " z3" );
                    being_state = States.y1_EXPLORER_BORN;
                    
                    
                    
                    break;
                case y1_EXPLORER_BORN:
                    if( e1_ENOUGH_ENERGY_TO_BORN ) {
                        log( BeingKind.CurrentType.EXPLORER, bi, " 1,     " );
                        z0_explorer_born( bi );
                        log( BeingKind.CurrentType.EXPLORER, bi, " z0" );
                        break;
                    }

                    if( e2_VICTUM_AVAILABLE ) {
                        log( BeingKind.CurrentType.EXPLORER, bi, " 2,      " );
                        being_state = States.y4_EXPLORER_ATTACK;
                        z1_explorer_attck( bi, victum );
                        log( BeingKind.CurrentType.EXPLORER, bi, " z1" );
                        break;
                    }                                                 
                    
                    log( BeingKind.CurrentType.EXPLORER, bi, "[else],       " );

                    being_state = States.y2_EXPLORER_SEARCH_FOOD;

                    continue;
                case y2_EXPLORER_SEARCH_FOOD:

                    if( e0_FOOD_AVAILABLE ) {
                        log( BeingKind.CurrentType.EXPLORER, bi, " 0,       " );
                        being_state = States.y3_EXPLORER_EAT;
                        continue;
                    } 
                    
                    log( BeingKind.CurrentType.EXPLORER, bi, "[else],      " );

                    z2_explorer_searchFood( bi );
                    
                    log( BeingKind.CurrentType.EXPLORER, bi, " z2" );

                    break;

                case y4_EXPLORER_ATTACK:

                    if( e2_VICTUM_AVAILABLE ) {
                        log( BeingKind.CurrentType.EXPLORER, bi, " 2,    " );
                        z1_explorer_attck( bi, victum );
                        log( BeingKind.CurrentType.EXPLORER, bi, " z1" );
                        break;
                    }
                    log( BeingKind.CurrentType.EXPLORER, bi, "[else],      " );
                    being_state = States.y1_EXPLORER_BORN;
                    continue;
            }
            break;
        }
        
    }
    
    private void z0_explorer_born( BeingInterface bi ) {
        BeingParams bp = getParams();
        bp.parameter = id;    
        
        
        bp.M = this.M * Constants.K_minbornvariation;
                    
        if( bp.M < Constants.K_minmass ) {
            bp.M = Constants.K_minmass;
        }
        
        take_action = new Event(EventKind.ACTION_BORN, bp);
    }
    
    private void z1_explorer_attck( BeingInterface bi, Integer victum ) {
        take_action = new Event(EventKind.ACTION_ATTACK, victum);
    }
    
    private void z2_explorer_searchFood( BeingInterface bi ) {        

        
        List<PointInfo> ns = bi.getNeighbourInfo(this);
        
        for (PointInfo n : ns) {
            // if one of our neighbour locations have enough evergy - 
            // move there
            if ( ( ( n.getCount(this) -  1 ) > ( M * E_min2 ) ) && 
                    ( ( n.getCount(this) -  1 ) > n.getGrowthRate( this ) ) ) {
                // OK, go this way and hope for the best
                take_action = new Event(EventKind.ACTION_MOVE_TO, n.getLocation());
                return;
            }
        }
        
        Location loc = razum.whereToGo( bi, this );
        
        if( loc != null ) {
            take_action = new Event( EventKind.ACTION_MOVE_TO, loc );
        } else {
            take_action = null;
        }
        
    }
    
    private void z3_explorer_eat( BeingInterface bi ) {
        take_action = new Event(EventKind.ACTION_EAT, M);
    }

    
    

    
    private void a2_guardian( BeingInterface bi ) {

        // information about point we're in
        PointInfo pi = bi.getPointInfo(this);
        // how much energy do we have now
        float e = bi.getEnergy(this);
        // how much energy available at cour current location
        float avail = pi.getCount(this) - 1;

        // array of all entities here        
        Integer[] ids = pi.getEntities( this, null );        
         // index of potential victum
        Integer aggressor = 0;
        Integer victum = 0;

        
        
        boolean e0_born_available = false;
        boolean e1_at_source = false;
        boolean e2_eat_avail = false;
        boolean e3_enemy_here = false;
        boolean e4_victum_avail = false;

        if( e >= ( M * ( E_born ) ) ) {
            e0_born_available = true;
        }
        
        if( pi.getLocation() == being_kind.getGuardObject() ) {
            e1_at_source = true;
        }
        
        if( avail > ( M * E_min ) ) {
            e2_eat_avail = true;
        }
        
        if( ids.length > 1 ) {
            List<Integer> enemy = new ArrayList();
            List<Integer> friend = new ArrayList();
            for( int i = 0; i < ids.length; i++ ) {
                if( bossHandle != bi.getOwner(this, ids[i]) ) {
                    enemy.add( ids[i] );
                } else {
                    friend.add( ids[i] );
                }
            }
            
            if( enemy.size() != 0 ) {

                float curr_enemy_mass;
                float min_enemy_mass = 10000f;

                for( int i = 0; i < enemy.size(); i++ ) {
                    curr_enemy_mass = bi.getMass( this, enemy.get( i ).intValue() );
                    if( curr_enemy_mass < min_enemy_mass ) {
                        min_enemy_mass = curr_enemy_mass;
                        aggressor = enemy.get( i );
                    }
                }
                
                // !!!!!!!!!!
                int idx = Util.rnd( enemy.size() );
                aggressor =  enemy.get( idx );
                // !!!!!!!!!!!
                
                e3_enemy_here = true;
            }
        }
        
        List <PointInfo> neighbours = bi.getNeighbourInfo( this );
        
        for( PointInfo neighbour : neighbours ) {
            // array of all entities here        
            Integer[] neighbour_ids = neighbour.getEntities( this, null );
             // index of potential victum
            Integer neighbour_victum = 0;
            
            if( neighbour_ids.length > 1 ) {
                List<Integer> enemy = new ArrayList();
                List<Integer> friend = new ArrayList();
                for( int i = 0; i < neighbour_ids.length; i++ ) {
                    if( bossHandle != bi.getOwner(this, neighbour_ids[i]) ) {
                        enemy.add( neighbour_ids[i] );
                    } else {
                        friend.add( neighbour_ids[i] );
                    }
                }

                if( enemy.size() != 0 ) {

                    int enemy_mass = 0;
                    int friend_mass = 0;

                    float curr_enemy_mass;
                    float min_enemy_mass = 10000f;

                    for( int i = 0; i < enemy.size(); i++ ) {
                        curr_enemy_mass = bi.getMass( this, enemy.get( i ).intValue() );
                        enemy_mass += curr_enemy_mass;
                        if( curr_enemy_mass < min_enemy_mass ) {
                            min_enemy_mass = curr_enemy_mass;
                            victum = enemy.get( i );
                        }
                    }

                    for( int i = 0; i < friend.size(); i++ ) {
                        friend_mass += bi.getMass( this, friend.get( i ).intValue() );
                    }

                    if( friend_mass * E_guard_attck_coef > enemy_mass &&
                      ( ( e / M - Constants.K_fightcost - Constants.K_emin ) * M  > 
                            min_enemy_mass * Constants.K_retaliate ) ) {
                        e4_victum_avail = true;
                    }

                }
            }
            
        }
        

        
        while( true ) {
            switch( being_state ) {
                
                default:
                    log( BeingKind.CurrentType.GUARDIAN, bi, "     " );
                    being_state = States.y1_GUARDIAN_BORN;
                    continue;
                    
                case y1_GUARDIAN_BORN:
                    if( e0_born_available ) {                        
                        log( BeingKind.CurrentType.GUARDIAN, bi, " 0,    " );
                        z0_guardian_born( bi, e1_at_source );
                        log( BeingKind.CurrentType.GUARDIAN, bi, " z0" );
                        break;
                    }
                    if( e1_at_source ) {
                        log( BeingKind.CurrentType.GUARDIAN, bi, " 1,       " );
                        being_state = States.y3_GUARDIAN_GUARD_SOURCE;
                        continue;
                    }
                    log( BeingKind.CurrentType.GUARDIAN, bi, "[else],        " );
                    being_state = States.y2_GUARDIAN_MOVE_TO_SOURCE;
                    z1_guardian_move_to_source( bi );
                    log( BeingKind.CurrentType.GUARDIAN, bi, " z1" );
                    break;

                case y2_GUARDIAN_MOVE_TO_SOURCE:
                    if( e1_at_source ) {
                        log( BeingKind.CurrentType.GUARDIAN, bi, " 1,        " );
                        being_state = States.y1_GUARDIAN_BORN;
                        continue;
                    }
                    z1_guardian_move_to_source( bi );
                    log( BeingKind.CurrentType.GUARDIAN, bi, " z1" );
                    break;
                    
                case y3_GUARDIAN_GUARD_SOURCE:
                    if( e3_enemy_here ) {
                        log( BeingKind.CurrentType.GUARDIAN, bi, " 3,       " );
                        being_state = States.y4_GUARDIAN_FIGHT;
                        z2_guardian_fight( bi, aggressor );
                        log( BeingKind.CurrentType.GUARDIAN, bi, " z2" );
                        break;
                    }
                    
                    if( e2_eat_avail ) {
                        log( BeingKind.CurrentType.GUARDIAN, bi, " 2,       " );
                        being_state = States.y5_GUARDIAN_EAT;
                        continue;
                    }
                    
                    if( e4_victum_avail ) {
                        log( BeingKind.CurrentType.GUARDIAN, bi, " 4,         " );
                        being_state = States.y6_GUARDIAN_MOVE_AND_ATTACK;
                        z5_guardian_move_and_attack( bi, victum ); //!!!!!!!!!!!
                        log( BeingKind.CurrentType.GUARDIAN, bi, " z5" );
                        break;
                    }
                    log( BeingKind.CurrentType.GUARDIAN, bi, "[else],        " );
                    being_state = States.y7_GUARDIAN_TRY_TO_GRANT;
                    continue;
                    
                case y4_GUARDIAN_FIGHT:
                    if( e3_enemy_here ) {
                        log( BeingKind.CurrentType.GUARDIAN, bi, " 3,    " );
                        z2_guardian_fight( bi, aggressor );
                        log( BeingKind.CurrentType.GUARDIAN, bi, " z2" );
                        break;
                    }
                    log( BeingKind.CurrentType.GUARDIAN, bi, "[else],       " );
                    being_state = States.y3_GUARDIAN_GUARD_SOURCE;
                    continue;
                    
                case y5_GUARDIAN_EAT:
                    log( BeingKind.CurrentType.GUARDIAN, bi, "     " );
                    being_state = States.y1_GUARDIAN_BORN;
                    z3_guardian_eat( bi );
                    log( BeingKind.CurrentType.GUARDIAN, bi, " z3" );
                    break;
                    
                case y6_GUARDIAN_MOVE_AND_ATTACK:
                    if( e4_victum_avail ) {
                        log( BeingKind.CurrentType.GUARDIAN, bi, " 4,      " );
                        z5_guardian_move_and_attack( bi, victum ); // !!!!!!!!!!!!
                        log( BeingKind.CurrentType.GUARDIAN, bi, " z5" );
                        break;
                    }
                    log( BeingKind.CurrentType.GUARDIAN, bi, "[else],          " );
                    being_state = States.y2_GUARDIAN_MOVE_TO_SOURCE;
                    continue;
                    
                case y7_GUARDIAN_TRY_TO_GRANT:
                    log( BeingKind.CurrentType.GUARDIAN, bi, "      " );
                    being_state = States.y1_GUARDIAN_BORN;
                    z4_guardian_try_to_grant( bi );
                    log( BeingKind.CurrentType.GUARDIAN, bi, " z4" );
                    break;
            }
            break;
        }
        
         if( log_on ) {
            bi.log( this, being_kind.getCurrent().toString() + 
                    "    being_state=" + being_state.toString() );
            bi.log( this, " M=" + String.valueOf( M ) + " e=" + String.valueOf( e ) + " S=" + String.valueOf( S ) );
            bi.log( this, " e0_born_available=" + String.valueOf( e0_born_available ) );
            bi.log( this, " e1_at_source=" + String.valueOf( e1_at_source ) );
            bi.log( this, " e2_eat_avail=" + String.valueOf( e2_eat_avail ) );
            bi.log( this, " e3_enemy_here=" + String.valueOf( e3_enemy_here ) );
            bi.log( this, " e4_victum_avail=" + String.valueOf( e4_victum_avail ) );
            bi.log( this, "-----------------------------------" );
                    
        }

    }
    
    private void z0_guardian_born( BeingInterface bi, boolean is_at_source ) {
        BeingParams bp = getParams();
        bp.parameter = id;
        if( is_at_source ) {
            bp.M = this.M * Constants.K_maxbornvariation;
//            bp.S = this.S * Constants.K_minbornvariation;
            
            if( bp.M > Constants.K_maxmass ) {
                bp.M = Constants.K_maxmass;
            }
            
//            if( bp.S < 2 ) {        //!!!!!!!!!!
//                bp.S = 2;
//            }
        }
        take_action = new Event(EventKind.ACTION_BORN, bp);
    }

    private void z1_guardian_move_to_source( BeingInterface bi ) {        
        take_action = new Event( EventKind.ACTION_MOVE_TO, 
                razum.moveTo( bi, this, being_kind.getGuardObject() ) );        
    }
    
    private void z2_guardian_fight( BeingInterface bi, Integer victum ) {
        take_action = new Event(EventKind.ACTION_ATTACK, victum);
        razum.achtung( bi, this );
        
        
    }
    
    private void z3_guardian_eat( BeingInterface bi ) {
        take_action = new Event(EventKind.ACTION_EAT, M);
    }
    
    private synchronized void z4_guardian_try_to_grant( BeingInterface bi ) {
        
//        if( ( bi.getEnergy( this ) / this.M ) < GUARDIAN_ENERGY_GIVE_THRESHOLD ) {
//            take_action = null;
//            return;
//        }
        
//        
//        Location curr_loc = bi.getLocation( this );
//        
//        List <Yeti_2> all_guards = razum.getGuardiansList( curr_loc );
//        
//        List <Yeti_2> all_guards_here = new ArrayList();
//        
//        if( all_guards == null ) {
//            take_action = null;
//            System.out.println( "gogno sluchilos'" );
//            return;
//        }
//        
//        for( Yeti_2 yeti : all_guards ) {
//            if( ( bi.getLocation( yeti ) == curr_loc ) && ( yeti != this ) ) {
//                all_guards_here.add( yeti );
//            }
//        }
//        
//        Yeti_2 most_strong = null;
//        
//        float most_strong_val = this.M;
//        
//        for( Yeti_2 yeti : all_guards_here ) {
//            if( ( yeti.M > most_strong_val ) && ( bi.getEnergy( yeti ) < 0.8 ) ) {
//                most_strong = yeti;
//                most_strong_val = yeti.M;
//            }
//        }
//        
//        if( most_strong != null ) {
//            take_action = new Event(EventKind.ACTION_GIVE, bi.getId( most_strong ), Math.min( bi.getEnergy( this ), ( most_strong.M - bi.getEnergy( most_strong ) ) ) );
//            all_guards.remove( most_strong );
//            return;
//        }
        
        take_action = null;
    }
    
    private void z5_guardian_move_and_attack( BeingInterface bi, Integer victum ) {
        take_action = new Event(EventKind.ACTION_MOVE_ATTACK, victum );
    }

    

    private void a3_warrior( BeingInterface bi ) {
        // information about point we're in
        PointInfo pi = bi.getPointInfo(this);
        // how much energy do we have now
        float e = bi.getEnergy(this);
        // how much energy available at cour current location
        float avail = pi.getCount(this) - 1;

        // array of all entities here        
        Integer[] ids = pi.getEntities( this, null );        
        
        
        
        boolean e0_at_assembly_point = false;
        boolean e1_enemy_here = false;
        boolean e2_eat_avail = false;
        boolean e3_signal_to_attack = false;
        boolean e4_freed = false;
        
        

        
        if( pi.getLocation() == being_kind.getAssemplyPoint() ) {
            e0_at_assembly_point = true;
        }

        if( ids.length > 1 ) {
            List<Integer> enemy = new ArrayList();
            List<Integer> friend = new ArrayList();
            for( int i = 0; i < ids.length; i++ ) {
                if( bossHandle != bi.getOwner(this, ids[i]) ) {
                    enemy.add( ids[i] );
                } else {
                    friend.add( ids[i] );
                }
            }
            
            if( enemy.size() > 0 ) {

                float curr_enemy_mass;
                float total_enemy_mass = 0;
                float min_enemy_mass = 10000f;

                for( int i = 0; i < enemy.size(); i++ ) {
                    curr_enemy_mass = bi.getMass( this, enemy.get( i ).intValue() );
                    total_enemy_mass += curr_enemy_mass;
                    if( curr_enemy_mass < min_enemy_mass ) {
                        min_enemy_mass = curr_enemy_mass;
                    }
                }
                
                e1_enemy_here = true;
                
            } else if( pi.getLocation() == being_kind.getTargetPoint() ) {
                e4_freed = true;
            }
        }

        
        if( avail > 0 ) {
            e2_eat_avail = true;
        }
        
        // signal to attack
        e3_signal_to_attack = being_kind.getAttackFlag();
        
        while( true ) {
            switch( being_state ) {
                
                default:
                    being_state = States.y1_WARRIOR_MOVE_TO_ASSEMBLY;
                    continue;
                    
                case y1_WARRIOR_MOVE_TO_ASSEMBLY:
                    if( e0_at_assembly_point ) {
                        being_state = States.y2_WARRIOR_READY_TO_ATTACK;
                        continue;
                    }
                    z0_warrior_move_to_assembly( bi );
                    break;
                case y2_WARRIOR_READY_TO_ATTACK:
                    if( e3_signal_to_attack ) {
                        being_state = States.y3_WARRIOR_ATTACK;
                        z3_warrior_move_and_attack( bi ); // !!!!!!!!!
                        break;
                    }
                    if( e1_enemy_here ) {
                        z1_warrior_fight( bi );
                    }
                    if( e2_eat_avail ) {
                        z2_warrior_eat( bi );
                        break;
                    }
                    
                    z5_warrior_wait( bi );
                    break;
                case y3_WARRIOR_ATTACK:
                    if( e4_freed ) {
                        being_state = States.y4_WARRIOR_SWITCH_TO_GUARDIAN;
                        continue;
                    }
                    // !!!!!!!!!!!!!!!!
                    if( pi.getLocation() != being_kind.getTargetPoint() ) {
                        if( pi.getLocation() == being_kind.getAssemplyPoint() ) {
                            z0_warrior_move_to_assembly( bi );
                            break;
                        }
                        z6_warrior_move_to_target( bi );
                        break;
                    }
                    // !!!!!!!!!!!!!!!!!!

                    z1_warrior_fight( bi );
                    break;
                case y4_WARRIOR_SWITCH_TO_GUARDIAN:
                    z4_warrior_switch_to_guardian( bi );
                    break;
            }
            break;
        }
        
    }
    
    private void z0_warrior_move_to_assembly( BeingInterface bi ) {        
        take_action = new Event( EventKind.ACTION_MOVE_TO, 
                razum.moveTo( bi, this, being_kind.getAssemplyPoint() ) );        
    }
    
    private Integer warrior_select_victim( BeingInterface bi ) {
        
        List<Integer> victum_list = razum.getEnemyIdList( being_kind.getTargetPoint() );

        if( ( victum_list != null ) && ( victum_list.size() > 0 ) ) {
            for( Integer vic : victum_list ) {
                if( razum.getEnemyMass( being_kind.getTargetPoint() , vic ) == 0 ) {
                    continue;
                } else {
                }

                if( razum.commitAttackOpearation( bi, vic, being_kind.getTargetPoint(), this, 
                        Constants.K_fight * this.M ) ) {
                    return  vic;
                }
            }
        }
        
        
        int idx = Util.rnd( victum_list.size() );
        return victum_list.get( idx );
    }
    
    private void z1_warrior_fight( BeingInterface bi ) {
        
        Integer victim = warrior_select_victim( bi );
        
        if( victim != null ) {        
            take_action = new Event( EventKind.ACTION_ATTACK, victim );
        } else {
            take_action = null;
        }

    }
    
    private void z2_warrior_eat( BeingInterface bi ) {
        take_action = new Event(EventKind.ACTION_EAT, M);
    }
  
    private void z3_warrior_move_and_attack( BeingInterface bi ) {

        Integer victim = warrior_select_victim( bi );
        
        if( victim != null ) {        
            take_action = new Event( EventKind.ACTION_MOVE_ATTACK, victim );
        } else {
            z6_warrior_move_to_target( bi );
        }
        
    }
    
    private void z6_warrior_move_to_target( BeingInterface bi ) {
            take_action = new Event( EventKind.ACTION_MOVE_TO, 
                razum.moveTo( bi, this, being_kind.getTargetPoint() ) );
        
    }
    
    private void z4_warrior_switch_to_guardian( BeingInterface bi ) {
        being_kind.setVictoryFlag( true );
    }
    
    private void z5_warrior_wait( BeingInterface bi ) {
        take_action = null; // need to implement
    }

    
    public void upgradeBeingKind( BeingKind bk ) {
        being_state = States.y0_INITIAL;
        being_kind = bk;
    }

    public BeingKind getBeingKind( ) {
        return being_kind;
    }

    
    public void analyzeEnemyPower( BeingInterface bi ) {
        // information about point we're in
        PointInfo pi = bi.getPointInfo(this);
        // array of all entities here        
        Integer[] ids = pi.getEntities( this, null );
        
        if( ids.length > 1 ) {
            List<Integer> enemy = new ArrayList();
            List<Integer> friend = new ArrayList();
            for( int i = 0; i < ids.length; i++ ) {
                if( bossHandle != bi.getOwner(this, ids[i]) ) {
                    enemy.add( ids[i] );
                } else {
                    friend.add( ids[i] );
                }
            }
            
            if( enemy.size() != 0 ) {

                int enemy_mass = 0;
                int friend_mass = 0;

                float curr_enemy_mass;
                float min_enemy_mass = 10000f;

                for( int i = 0; i < enemy.size(); i++ ) {
                    curr_enemy_mass = bi.getMass( this, enemy.get( i ).intValue() );
                    enemy_mass += curr_enemy_mass;
                    if( curr_enemy_mass < min_enemy_mass ) {
                        min_enemy_mass = curr_enemy_mass;
                    }
                }

                for( int i = 0; i < friend.size(); i++ ) {
                    friend_mass += bi.getMass( this, friend.get( i ).intValue() );
                }

                if( friend_mass * 0.8 < enemy_mass ) {
                    razum.setOccupied( bi.getLocation( this ) );
//                    bi.log( this, "Set Occupied " +  bi.getLocation( this ).toString() );
                } 
                razum.setEnemyPowerInfo( bi, this, bi.getLocation( this ), enemy_mass, enemy );
                
            } else {
                 // not occupied
                 razum.clearOccupied( bi.getLocation( this ) );
//                 bi.log( this, "Clear Occupied " +  bi.getLocation( this ).toString() );
            }
        }
    }
    
    
    
    public synchronized void processEvent(BeingInterface bi, Event e) {
        switch (e.kind()) {
            case BEING_BORN:
                // increase population counter
                currentCount++;                
                init(bi, bi.getId(this), (BeingParams)e.param());
                break;
            case BEING_DEAD:
                switch( being_kind.getCurrent() ) {
                    case EXPLORER:
                        razum.delExplorer( bi, this );
                        break;
                    case GUARDIAN:
                        razum.delGuardian( bi, this, being_kind );
                        break;
                    case WARRIOR:
                        razum.delWarrior( bi, this );
                        break;
                }
                
                // gonna get dead, decrease population counter
                currentCount--;
//                bi.log(this, "dying...");
                analyzeEnemyPower( bi );
                population.remove( this );
                break;
            case BEING_ATTACKED:
                // now just print if one attacks us
//                bi.log(this, "attacked by "+e.sender()+" of "+
//                       bi.getOwner(this, e.sender())+" damage: "+e.param() + 
//                       " my_cuurent_energy_level=" + ( bi.getEnergy( this ) / this.M ) );
//                analyzeEnemyPower( bi );
                break;
            case BEING_ENERGY_GIVEN:
                // ... or gives a gift
//                bi.log(this, "got "+e.param()+" energy from "+e.sender());
                break;
        }
    }
    
    public String getName() {
        return "yeti_2";
    }
    
    // this method is invoked once per game, to make sure all static are properly inited
    public void reinit(UserGameInfo info) {	
        currentCount = 0;
        bossHandle = null;
	Util.log("game "+info.kind+ " maxTurns="+info.maxTurns);
    }
    
    // return our parameters
    public BeingParams getParams() {
        BeingParams bp = new BeingParams(M0, S0);
        return bp;
    }
    
    // who this entity belongs to (and score accounted for)
    public String getOwnerName() {
        return "Yeti_2";
    }
    
    private void init(BeingInterface bi, Integer id, BeingParams bp) {
         this.id = id;
         this.M  = bp.M;
         this.S  = bp.S;
         this.E_eat = 0.6f * M;
         this.others = new Integer[1];
         
         
         if (bossHandle == null) {
             bossHandle = bi.getOwner(this, id);
             population = new ArrayList();
             razum = new Consciousness( bi, this, population );
         } 
         
                           
         being_kind = razum.chooseNewBornBeingKind( bi, this );
         
         population.add( this );             
    }    
}
